package commandSystem;

import Events.CallFromElevatorEvent;
import Events.CallFromFloorEvent;
import Events.ReachedFloorEvent;

public class Test {

	private static boolean running = false;
	private static InstructionQueue queue;

	private static Direction currentDirection = Direction.UP;
	private static int currentFloor = 0;

	public static void iter() {
		int nextDestination = queue.getNextInstruction();
		
		if (!running) {
			// would be -1 if the queue doesn't have any next instruction

			//System.out.println("next dest : " + nextDestination);
			if (nextDestination != -1) {
				running = true;
				currentDirection = currentFloor < nextDestination ? Direction.UP : Direction.DOWN;
			}
		} else {
			//System.out.println("not running");
			// if we just reached a new floor
			if (currentFloor == nextDestination) {
				queue.computeEvent(new ReachedFloorEvent(currentFloor, currentDirection));
				running = false;
			} else {
				currentDirection = currentFloor < nextDestination ? Direction.UP : Direction.DOWN;
				currentFloor += currentDirection == Direction.UP ? 1 : -1;
			}
		}
		System.out.println("elevator floor " + currentFloor + " direction " +
			 (currentDirection) + " running: " + running);
	}

	public static void main(String[] args) {
		queue = new BasicInstructionQueue();
		iter();
		iter();
		queue.computeEvent(new CallFromFloorEvent(2, Direction.DOWN));
		System.out.println("someone calls from floor 2 to go down");
		iter();
		queue.computeEvent(new CallFromFloorEvent(1, Direction.UP));
		System.out.println("someone calls from floor 1 to go up");
		iter();

		queue.computeEvent(new CallFromElevatorEvent(5));
		System.out.println("the guy who entered calls for floor 5");

		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();
		iter();

	}
}
